/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 *  ianjuta-vcs.h -- Autogenerated from libanjuta.idl
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef _IANJUTA_VCS_H_
#define _IANJUTA_VCS_H_

#include <glib-object.h>

G_BEGIN_DECLS

#define IANJUTA_TYPE_VCS (ianjuta_vcs_get_type ())
#define IANJUTA_VCS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IANJUTA_TYPE_VCS, IAnjutaVcs))
#define IANJUTA_IS_VCS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IANJUTA_TYPE_VCS))
#define IANJUTA_VCS_GET_IFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), IANJUTA_TYPE_VCS, IAnjutaVcsIface))

#define IANJUTA_VCS_ERROR ianjuta_vcs_error_quark()

typedef struct _IAnjutaVcs IAnjutaVcs;
typedef struct _IAnjutaVcsIface IAnjutaVcsIface;


struct _IAnjutaVcsIface {
	GTypeInterface g_iface;
	

	void (*add) (IAnjutaVcs *obj, const gchar* filename, GError **err);
	void (*commit) (IAnjutaVcs *obj, const gchar* filename,  const gchar* log,  gboolean recurse, GError **err);
	void (*remove) (IAnjutaVcs *obj, const gchar* filename, GError **err);
	void (*update) (IAnjutaVcs *obj, const gchar* filename,  gboolean recurse, GError **err);

};

GQuark ianjuta_vcs_error_quark     (void);
GType  ianjuta_vcs_get_type        (void);

void ianjuta_vcs_add (IAnjutaVcs *obj, const gchar* filename, GError **err);

void ianjuta_vcs_commit (IAnjutaVcs *obj, const gchar* filename,  const gchar* log,  gboolean recurse, GError **err);

void ianjuta_vcs_remove (IAnjutaVcs *obj, const gchar* filename, GError **err);

void ianjuta_vcs_update (IAnjutaVcs *obj, const gchar* filename,  gboolean recurse, GError **err);


G_END_DECLS

#endif
